"""
Auto generated by Mercado Radar SDK Generator
2025-02-27 21:31:37
"""

from ..models._filter import Filter as FilterSchema
from ..models._paginated_response import PaginatedResponse


class Filter:

    def __init__(self, client):
        self.client = client

    def list(self, limit:int, offset:int, model:str) -> PaginatedResponse[FilterSchema]:
        """
        List all available filters

        Returns a list of filters available for the specified model
        """
        data = {
            "limit": limit,
            "offset": offset,
            "model": model,
        }
        data = {k: v for k, v in data.items() if v is not None}

        response = self.client.get(url=f"/v3/filter/", params=data)

        response.raise_for_status()

        data = response.json()

        count = data.get('count', 0)
        next_page = data.get('next')
        previous_page = data.get('previous')
        results = data.get('results')

        parsed_results = []
        for result in results:
            parsed_results.append(FilterSchema(**result))

        parsed_paginated_response = {"count": count, "next": next_page, "previous": previous_page, "results": parsed_results}

        return PaginatedResponse(**parsed_paginated_response)

